export class CraftingManager extends ISpriteInstance
{
	constructor(){
		super();
	}
	
	getRecipeList(...craftingStations){
		const allRecipes = this.runtime.objects.recipeData.getFirstInstance().getJsonDataCopy();
		let playerRecipes = allRecipes['player'];
		
		
		for(const station of craftingStations){
		
			if(station && allRecipes.hasOwnProperty(station.objectType.name)){
				const stationRecipes = allRecipes[station.objectType.name];
				playerRecipes = Object.assign(playerRecipes, stationRecipes);
			}
		
		}
		
		return Object.entries(playerRecipes);
	}
	
	canCraft(recipe, inventory) {
		for(const item of recipe){
			const hasItem = inventory.hasItem(item[0], item[1]);
			if(!hasItem) {
				return false;
			}
		}
		
		return true;
	}
	
	craft(id, recipe, inventory){
		const itemData = this.runtime.objects.itemData.getFirstInstance().getJsonDataCopy()
		
		for(const item of recipe){
			inventory.removeItem(item[0], item[1]);
		}
		
		const added = inventory.add(id, {
			stackSize: itemData[id].maxStackSize
		});
		
		if(!added){
			const player = this.runtime.objects.playerMask.getFirstPickedInstance();
			this.runtime.callFunction('drop', id, player.x, player.y, false);
		}
		
		this.runtime.callFunction('createInventoryHUD');
	}
}

