
// Import any other script files here, e.g.:
import {CraftingManager} from "./crafting.js";
import {PlayerManager} from "./player.js";

runOnStartup(async runtime =>
{
	// Code to run on the loading screen.
	// Note layouts, objects etc. are not yet available.
	
	runtime.objects.craftingManager.setInstanceClass(CraftingManager);
	runtime.objects.playerManager.setInstanceClass(PlayerManager);
	
	runtime.addEventListener("beforeprojectstart", () => OnBeforeProjectStart(runtime));
	
	globalThis._runtime = runtime;
});

async function OnBeforeProjectStart(runtime)
{
	//import item data
	const world = await runtime.assets.fetchJson('worldItems.json');
	runtime.objects.worldItems.getFirstInstance().setJsonDataCopy(world);
	
	const items = await  runtime.assets.fetchJson('items.json');
	runtime.objects.itemData.getFirstInstance().setJsonDataCopy(items);
	
	const recipes = await  runtime.assets.fetchJson('recipes.json');
	runtime.objects.recipeData.getFirstInstance().setJsonDataCopy(recipes);
}


